<?php
	//
	// Pattern definitions for db tables in current project.
	//

	/**
	 * Pattern class definition for interface Generic_DB.
	 *
	 * @package
	 * @author Daniel Schliebner
	 * @copyright Copyright (c) 2010
	 * @access public
	 */
	class DBDynPGDatabaseHandle extends Generic_DB {
		// db settings

			var $db_host 		 = MYSQL_SERVER;
			var $db_user 		 = MYSQL_USER;
			var $db_password 	 = MYSQL_PASSWORD;
			var $db_port 		 = '';
			var $db_connect_type = 'tcp';
			var $db_socket 		 = '';
			var $db_name 		 = MYSQL_DATABASE;
			var $fetch_by 		 = 'assoc';
			var $debug 			 = false;

		// internal properties

			// -


		// tbl definitions

			var $tbl_container = Array(
										//
                                        // dynpg_cms_article :=
                                        //
                                        'dynpg_cms_article' => Array(
                                        	'rows' => Array(
                                        		'GROUP',
                                        		'TITLE',
                                        		'LEAD',
                                        		'DATE_UP',
                                        		'DATE_TO',
                                        		'TIME_UP',
                                        		'TIME_TO',
                                        		'CONTENT',
                                        		'ISPUBLIC',
                                        		'ISATHOME',
                                        		'CREATEDATE',
                                        		'DATEFIX',
                                        		'SHOWVISITS',
                                        		'SHOWDATE',
                                        		'SEARCHKEYS',
                                        		'INDEX',
                                        		'OWNER',
                                        		'MODIFIER',
                                        		'CHANGED',
                                        		'AUTO_DELETE',
                                                'META_TITLE',
                                                'META_KEYWORDS',
                                                'META_DESCRIPTION'
                                        	),
                                        	'indexes' => Array(
                                        		'TITLE',
                                        		'LEAD',
                                        		'SEARCHKEYS'
                                        	),
                                        	'fulltext' => Array(
                                        	   'LEAD',
                                        	   'SEARCHKEYS',
                                        	   'TITLE'
                                            ),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_articles_assoc :=
                                        //
                                        'dynpg_cms_articles_assoc' => Array(
                                        	'rows' => Array(
                                        		'article_id_fk',
                                        		'assoc_article_id_fk',
                                        		'title'
                                        	),
                                        	'indexes' => Array(
                                        		'title'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => ''
                                        ),

                                        //
                                        // dynpg_cms_article_options :=
                                        //
                                        'dynpg_cms_article_options' => Array(
                                        	'rows' => Array(
                                        		'article_id_fk',
                                        		'option_id_fk'
                                        	),
                                        	'indexes' => Array(),
                                        	'fulltext' => Array(),
                                        	'increment_key' => ''
                                        ),

                                        //
                                        // dynpg_cms_article_options_lang :=
                                        //
                                        'dynpg_cms_article_options_lang' => Array(
                                        	'rows' => Array(
                                        		'description',
                                        		'language'
                                        	),
                                        	'indexes' => Array('description'),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'option_id'
                                        ),

                                        //
                                        // dynpg_cms_articletexts :=
                                        //
                                        'dynpg_cms_articletexts' => Array(
                                        	'rows' => Array(
                                        		'TEXT',
                                        		'GROUP'
                                        	),
                                        	'indexes' => Array(
                                        	),
                                        	'fulltext' => Array(
                                        	   'TEXT'
                                            ),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_bin :=
                                        //
                                        'dynpg_cms_bin' => Array(
                                        	'rows' => Array(
                                        		'bin_id',
                                        		'type_hash',
                                        		'version',
                                        		'installdomain',
                                        		'set_maxupload_kb',
                                        		'set_filetypes',
                                        		'set_show_fonts',
                                        		'set_show_inline_popups'
                                        	),
                                        	'indexes' => Array(
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => ''
                                        ),

                                        //
                                        // dynpg_cms_counter :=
                                        //
                                        'dynpg_cms_counter' => Array(
                                        	'rows' => Array(
                                        		'section',
                                        		'visits'
                                        	),
                                        	'indexes' => Array(
                                        		'section'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => ''
                                        ),

                                        //
                                        // dynpg_cms_counter_log :=
                                        //
                                        'dynpg_cms_counter_log' => Array(
                                        	'rows' => Array(
                                        		'ip',
                                        		'site_query',
                                        		'timestamp',
                                        		'identity'
                                        	),
                                        	'indexes' => Array(
                                        		'ip',
                                        		'site_query',
                                        		'identity'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_editor_css_def :=
                                        //
                                        'dynpg_cms_editor_css_def' => Array(
                                        	'rows' => Array(
                                        		'CLASSNAME',
                                        		'DETAILNAME'
                                        	),
                                        	'indexes' => Array(
                                        		'CLASSNAME',
                                        		'DETAILNAME'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_group_treestruct :=
                                        //
                                        'dynpg_cms_group_treestruct' => Array(
                                        	'rows' => Array(
                                        		'root_id_fk',
                                        		'element_id_fk',
                                        		'successor_id_fk'
                                        	),
                                        	'indexes' => Array(

                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => ''
                                        ),

                                        //
                                        // dynpg_cms_groups :=
                                        //
                                        'dynpg_cms_groups' => Array(
                                        	'rows' => Array(
                                        		'INDEX',
                                        		'REFID',
                                        		'REFID_IS_START',
                                        		'NAME',
                                        		'SHORTTEXT',
                                        		'IMAGE',
                                        		'ALIGN',
                                        		'CREATEDATE',
                                        		'SHOWVISITS',
                                        		'PUBLIC',
                                        		'PUBLIC_FROM',
                                        		'PUBLIC_UNTIL',
                                                'META_TITLE',
                                                'META_KEYWORDS',
                                                'META_DESCRIPTION'
                                        	),
                                        	'indexes' => Array(
                                        		'NAME'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_groups_assoc :=
                                        //
                                        'dynpg_cms_groups_assoc' => Array(
                                        	'rows' => Array(
                                        		'group_id_fk',
                                        		'article_id_fk',
                                        		'title',
                                        		'subgroups'
                                        	),
                                        	'indexes' => Array(
                                        		'title'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => ''
                                        ),

                                        //
                                        // dynpg_cms_guestbook :=
                                        //
                                        'dynpg_cms_guestbook' => Array(
                                        	'rows' => Array(
                                        		'author',
                                        		'email',
                                        		'hp',
                                        		'isfrom',
                                        		'subtext',
                                        		'datecreated',
                                        		'code'
                                        	),
                                        	'indexes' => Array(
                                        		'author',
                                        		'email',
                                        		'hp',
                                        		'isfrom',
                                        		'datecreated',
                                        		'code'
                                        	),
                                        	'fulltext' => Array(
                                        	   'author',
                                        	   'subtext'
                                            ),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_imagegroup_treestruct :=
                                        //
                                        'dynpg_cms_imagegroup_treestruct' => Array(
                                        	'rows' => Array(
                                        		'root_id_fk',
                                        		'element_id_fk',
                                        		'successor_id_fk'
                                        	),
                                        	'indexes' => Array(

                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => ''
                                        ),

                                        //
                                        // dynpg_cms_imagegroups :=
                                        //
                                        'dynpg_cms_imagegroups' => Array(
                                        	'rows' => Array(
                                        		'NAME',
                                        		'SHORTTEXT'
                                        	),
                                        	'indexes' => Array(
                                        		'NAME'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_images :=
                                        //
                                        'dynpg_cms_images' => Array(
                                        	'rows' => Array(
                                        		'NAME',
                                        		'URL',
                                        		'DESCR',
                                        		'USERGROUP'
                                        	),
                                        	'indexes' => Array(
                                        		'NAME',
                                        		'URL',
                                        		'DESCR'
                                        	),
                                        	'fulltext' => Array(
                                                'NAME',
                                                'DESCR'
                                            ),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_leadimages :=
                                        //
                                        'dynpg_cms_leadimages' => Array(
                                        	'rows' => Array(
                                        		'IID',
                                        		'AID',
                                        		'ALIGN'
                                        	),
                                        	'indexes' => Array(

                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_mailadresses :=
                                        //
                                        'dynpg_cms_mailadresses' => Array(
                                        	'rows' => Array(
                                        		'adr_id',
                                        		'title',
                                        		'mail',
                                        		'language'
                                        	),
                                        	'indexes' => Array(
                                        		'title',
                                        		'mail',
                                        		'language'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'adr_primary_id'
                                        ),

                                        //
                                        // dynpg_cms_mailtexts :=
                                        //
                                        'dynpg_cms_mailtexts' => Array(
                                        	'rows' => Array(
                                        		'm_id',
                                        		'title',
                                        		'mailto',
                                        		'mailref',
                                        		'mailfrom',
                                        		'mailreply',
                                        		'mailtext',
                                        		'type',
                                        		'language'
                                        	),
                                        	'indexes' => Array(
                                        		'title',
                                        		'mailto',
                                        		'mailref',
                                        		'mailfrom',
                                        		'mailreply',
                                        		'type',
                                        		'language'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'm_primary_id'
                                        ),

                                        //
                                        // dynpg_cms_plugin_rights :=
                                        //
                                        'dynpg_cms_plugin_rights' => Array(
                                        	'rows' => Array(
                                        		'user_id_fk',
                                        		'plugin',
                                        		'right_bin'
                                        	),
                                        	'indexes' => Array(),
                                        	'fulltext' => Array(),
                                        	'increment_key' => ''
                                        ),

                                        //
                                        // dynpg_cms_preview :=
                                        //
                                        'dynpg_cms_preview' => Array(
                                        	'rows' => Array(
                                        		'TEXT'
                                        	),
                                        	'indexes' => Array(

                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_rights :=
                                        //
                                        'dynpg_cms_rights' => Array(
                                        	'rows' => Array(
                                        		'USERID',
                                        		'PARENT',
                                        		'SECTION',
                                        		'CREATE',
                                        		'DELETE',
                                        		'CHANGE',
                                        		'PUBLISH'
                                        	),
                                        	'indexes' => Array(
                                        		'PARENT'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_textgroups :=
                                        //
                                        'dynpg_cms_textgroups' => Array(
                                        	'rows' => Array(
                                        		'NAME'
                                        	),
                                        	'indexes' => Array(
                                        		'NAME'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'id'
                                        ),

                                        //
                                        // dynpg_cms_user :=
                                        //
                                        'dynpg_cms_user' => Array(
                                        	'rows' => Array(
                                        		'NAME',
                                        		'PASSWORD',
                                        		'ADMINISTRATIVE',
                                        		'AUTARKIC',
                                        		'GIVERIGHT',
                                        		'DOVOTES',
                                        		'DOGUESTBOOK',
                                        		'DOBASKET',
                                        		'DOFORUM',
                                        		'DOSTATISTICS',
                                        		'LANGUAGE',
                                        		'EDIT_MODE',
                                        		'INTERN',
                                        		'RIGHTS'
                                        	),
                                        	'indexes' => Array(
                                        		'NAME',
                                        		'PASSWORD',
                                        		'LANGUAGE'
                                        	),
                                        	'fulltext' => Array(),
                                        	'increment_key' => 'id'
                                        )
								 );

		// constructor

			function DBDynPGDatabaseHandle() {
				if (! defined('MATCH')) {
					define('MATCH', create_function('$query, $class', 'return $class->db_matchQuery($query, "matchIndex");'));
				}
				register_shutdown_function(array(&$this, 'destroy_DBDynPGDatabaseHandle'));
			}

		// destructor

			function destroy_DBDynPGDatabaseHandle() {
				@ob_end_flush();
        	}

		// general methods

			// function getMatchQuery: x string -> string
			// Returns the table-specific sql match query.
			function getMatchQuery($query) {
				return call_user_func(MATCH, $query, $this);
			}


			// procedure switchDebug: [x string]
			// Switches between the available debug modes and buffers the output
			// to add a <br />-tag instead of each line feed.
			function switchDebug($mode = 'debug') {
				if ( $this->debug === false ) {
					@ob_start(create_function('$buffer', 'return nl2br($buffer);'));
					$this->db_setDebugMode($mode);
				} else {
					@ob_end_flush();
					$this->db_setDebugMode(false);
				}
			}
	}
?>