<?php
    // set header informations, start session and set error_reporting

    @header("Content-Type: text/html; charset=UTF-8");
	@session_start();

	// setup debug mode

    if (!empty($GLOBALS['cfg']["config_Debug_Mode"]) && $GLOBALS['cfg']["config_Debug_Mode"]) {
		@error_reporting(E_ALL);
		@ini_set('display_errors', 1);
	} else {
		@error_reporting(0);
		@ini_set('display_errors', 0);
	}


    // do logout process

	if ( isset($_POST["LOGOUT"]) && $_POST["LOGOUT"]=='PERFORM' ) {
		@session_unset();
		@session_destroy();
	}


    // imports

	require_once "defines.php";
	require_once "functions.php";
	require_once "connectdb.php";


    // normalize POST/GET data

    function nPOST(&$array = false) {
        if ($array === false)
            $array = &$_POST;

        foreach ($array as $key => &$value) {
            // we have to skip this key in order to
            // support sajax
            if ($key == 'rsargs')
                continue;

            if (get_magic_quotes_gpc())
                if (is_array($value))
                    nPOST($value);
                else
                    $value = stripslashes($value);
        }
    }
    nPOST();

    // normalize GET data

    function nGET(&$array = false) {
        if ($array === false)
            $array = &$_GET;

        foreach ($array as $key => &$value) {
            // we have to skip this key in order to
            // support sajax
            if ($key == 'rsargs')
                continue;

            if (is_array($value))
                nGET($value);
            else
                $value = mysql_real_escape_string(get_magic_quotes_gpc()? stripslashes($value): $value);
        }
    }
    nGET();


    // login or verify

	if ( (isset($_POST["SYSTEM_NAME"])) && (isset($_POST["SYSTEM_PASSWORD"])) ) {

    	// fetch user

            $ROW = mysql_fetch_object(
                $RES = mysql_query(
                    "SELECT * FROM `dynpg_cms_user` WHERE `NAME`='".mysql_real_escape_string($_POST['SYSTEM_NAME'])."' AND PASSWORD( '" . mysql_real_escape_string($_POST['SYSTEM_PASSWORD']) . "' )=`PASSWORD` AND `INTERN`='FALSE'"
                )
            );


		// security check: maybe mysql_num_rows counts from -1 or sth. is wrong - so password and name is proofed again.

    		if ( (mysql_num_rows($RES) > 0) ) {
    			$_SESSION["ID"] 		 = $ROW->id;
    			$_SESSION["DPG_SESS_ID"] = $ROW->id;
    			$_SESSION["NAME"] 		 = $ROW->NAME;
    			$_SESSION["PASSWORD"] 	 = $ROW->PASSWORD;
    			$_SESSION["ADMINISTRATIVE"] = $ROW->ADMINISTRATIVE;
    			$_SESSION["AUTARKIC"] 	 = $ROW->AUTARKIC;
    			$_SESSION["GIVERIGHT"] 	 = $ROW->GIVERIGHT;
    			$_SESSION["DOVOTES"] 	 = $ROW->DOVOTES;
    			$_SESSION["DOGUESTBOOK"] = $ROW->DOGUESTBOOK;
    			$_SESSION["DOBASKET"]	 = $ROW->DOBASKET;
    			$_SESSION["DOFORUM"]	 = $ROW->DOFORUM;
    			$_SESSION["DOSTATISTICS"] = $ROW->DOSTATISTICS;
    			$_SESSION["BACKEND_EDIT_MODE"] = ($ROW->EDIT_MODE == 'TRUE');
    			$_SESSION["LANGUAGE"]	 = strtolower($ROW->LANGUAGE);
    			$_SESSION["DPGEM_INIT"]  = true;
    		}
	}


    // fetch current language settings

	if ( VerifyAccess() ) {
		if ( isset($_POST["SET_LANGUAGE"]) && isset($_POST["CHG_DYNPG_SET_LANGUAGE"]) && preg_match('/[^a-zA-Z]/', $_POST["CHG_DYNPG_SET_LANGUAGE"]) == 0 && is_file('localised/'.strtolower($_POST["CHG_DYNPG_SET_LANGUAGE"]).'.lang.php')) {
			$_SESSION["LANGUAGE"] = $_POST["CHG_DYNPG_SET_LANGUAGE"];
		}
	} else {
        unset($_SESSION["LANGUAGE"]);
	}

    if( empty($_SESSION["LANGUAGE"]) ){
        $_SESSION["LANGUAGE"] = dynpg_backend_language();
    }

    $_SESSION["LANGUAGE"] = preg_replace('/[^a-zA-Z]+/', '', $_SESSION["LANGUAGE"]);


    // load additional libaries

    // always load
    require_once "languages.inc.php";
    require_once "plugins/languages.inc.php";
    require_once "plugins/rights.php";

    // only load if login exists
    if (VerifyAccess()) {
        if (dynpg_json_available()) {
            require_once "sajax.php";
            require_once "sajax_export.php";
        }
    }


    // register global sajax calls

    if (VerifyAccess()) {
        if (dynpg_json_available())
            dpg_sajax_exports();

        function dpgem_backend_switch_editmode() {
            if (!isset($_SESSION["ID"]))
                return false;
            $row = mysql_fetch_assoc(
                mysql_query("SELECT `EDIT_MODE` FROM `dynpg_cms_user` WHERE `id` = '".mysql_real_escape_string($_SESSION['ID'])."'")
            );
            $em = $row['EDIT_MODE'] == 'TRUE'? 'FALSE': 'TRUE';
            mysql_query("UPDATE `dynpg_cms_user` SET `EDIT_MODE` = '{$em}' WHERE `id` = '".mysql_real_escape_string($_SESSION['ID'])."'");
            $_SESSION["BACKEND_EDIT_MODE"] = ($em == 'TRUE');
            return ($em == 'TRUE');
        }

        // if json is not available, call as usual
        if (!dynpg_json_available() && !empty($_GET['switchEditMode'])) {
            dpgem_backend_switch_editmode();
            header('Location: ' . dynpg_get_HTTP_URL() . '?' . preg_replace('/(&){0,1}switchEditMode=(\w+)/', '', getenv('QUERY_STRING')));
            exit;
        }
    }
?>
<!DOCTYPE html>

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

        <title><?php echo htmlentities(C_TOOL_TITLE); ?></title>

        <link rel="stylesheet" type="text/css" href="css/tool.css">
        <link rel="stylesheet" type="text/css" href="css/config_general.css">

        <!-- different JavaScript functions -->
        <script src="js/java.js" type="text/javascript"></script>

        <!-- jQuery repository -->
        <script src="js/jquery.js" type="text/javascript"></script>
        <script src="js/jquery-loading-effects.js" type="text/javascript"></script>
        <script src="js/jquery.md5.js" type="text/javascript"></script>

        <!-- JavaScript sorting and dynamic layers -->
        <script src="js/hwnd.js" type="text/javascript"></script>
        <script src="js/table-sort.js" type="text/javascript"></script>

        <!-- JavaScript calendar -->
        <script type="text/javascript">
        <!--
        // Language Code for Calendar
        var calendarLanguageCode = '<?php print $_SESSION["LANGUAGE"]; ?>';
        //-->
        </script>
        <script src="js/calendar/js_calendar.js" type="text/javascript"></script>

<?php if (VerifyAccess() && dynpg_json_available()) { ?>
        <!-- SAJAX repository -->
        <script src="js/sajax/json2.stringify.js" type="text/javascript"></script>
        <script src="js/sajax/json_stringify.js" type="text/javascript"></script>
        <script src="js/sajax/json_parse_state.js" type="text/javascript" ></script>
        <script src="js/sajax/sajax.js" type="text/javascript" ></script>
<?php } ?>

        <!-- Adobe Spry framework -->
        <script src="js/spry/SpryEffects.js" type="text/javascript"></script>

        <!-- Backend JS GUI functions (using SJAX if available) -->
        <script src="js/sajax-repos.js" type="text/javascript"></script>
<?php if (VerifyAccess() && dynpg_json_available()) { ?>
        <script type="text/javascript">
        <!--
        var success_activated = '<?php print $GLOBALS["lang_dpg"]->str["lang_menu_top_activated"]; ?>';
        var success_deactivated = '<?php print $GLOBALS["lang_dpg"]->str["lang_menu_top_deactivated"]; ?>';

        <?php print sajax_show_javascript(); ?>

        function dpgem_backend_switch_editmode() {
            show_presentation_effect();
            process_dialog();
            x_dpgem_backend_switch_editmode(function(z) {
                $('#fem_btn_1').toggle();
                $('#fem_btn_2').toggle();
                success_dialog(z? success_activated: success_deactivated, 'global_success_dialog');
                close_dialog();
            });
            return false;
        }
        //-->
        </script>
<?php } else { ?>
        <script type="text/javascript">
        <!--
        function dpgem_backend_switch_editmode() { return true; }
        //-->
        </script>
<?php } ?>

        <!-- Loading screen -->
        <script type="text/javascript">
        <!--
        $(document).ready(function() {
            $("#loadingBar").css('top', Math.floor($(window).height() / 2) + $(window).scrollTop() - $("#loadingBar").height());
            $("#loadingBar").css('left', Math.floor($(window).width() / 2) + $(window).scrollLeft());

            $("#container").css('opacity', 0.2);
            $("#loadingBar").show();
        });
        $(window).load(function() {
            $('#loadingBar').fadeOut(500);
            $('#container').fadeTo('fast', 1);
        });
        //-->
        </script>

        <?php
        	if (VerifyAccess() && !empty($_GET['show'])) {
				// For view ID = 1
				if ($_GET['show']=="1")
					require 'tinymce.inc.php';

                // For view ID = 3
				if ($_GET['show']=="3")
					require 'tinymce.inc.php';

				// For view ID = 4
				if ($_GET['show']=="4") {
					if ( empty($_POST["SUBMIT_BTN"]) ) {
				        $_POST["SUBMIT_BTN"] = '';
				    }
					if (! ( (dynpg_htmlentities_rigid($_POST["SUBMIT_BTN"],ENT_COMPAT,true) == $GLOBALS["lang_dpg"]->str["lang_texts_create2_button"] ||
							 dynpg_htmlentities_rigid($_POST["SUBMIT_BTN"],ENT_COMPAT,true) == $GLOBALS["lang_dpg"]->str["lang_texts_change2_button"])
							 && !empty($_POST["TEXT_TO_ARTICLE"]) ) ) {
						require 'tinymce.inc.php';
				    }
				}
        	}
        ?>
    </head>

    <body>

	<a name="top"></a>

	<div id="loadingBar" style="display:none;"><img src="pictures/loading_bar.gif" alt="loading..." /></div>

	<div id="dynamic-container" style="filter:alpha(opacity=10); -moz-opacity: 0.1; opacity: 0.1; width: 100%; position: absolute; z-index: 100; background-color: white; display: none;"></div>

	<div id="global_success_dialog" style="color: green; font-weight: bold;" class="multifunctionLayer"></div>

	<div id="container">

	<table border="0" Cellpadding="0" Cellspacing="0" width="100%" height="100%" class="WebSiteTable">
		<tr>
			<td valign="top" align="left" width="100%" style="background-image: url('pictures/head-bg.jpg');">
				<table border="0" Cellpadding="0" Cellspacing="0" width="100%">
				 <tr>
				  <td valign="top" align="left">
  					<table border="0" cellpadding="0" cellspacing="0" width="100%" style="margin-left:20px;">
              <tr>
                <td width="60">
                  <?php
                    if ( !VerifyAccess() ) {
                      ?>
                      <img src="pictures/head_news.jpg" alt="DynPG - Dynamic Pages"/>
                      <?php
                    }
                  ?>
                </td>
                <td valign="top">
                  <?php
                    if ( VerifyAccess() ) {
                      require 'horizontalmenu.php';
                    }
                    else{
                      ?>
                      <div style="position: absolute;margin-left:280px;">
                        <a href="<?php echo $GLOBALS["lang_dpg"]->str["lang_head_support_link"]; ?>" target="_blank"><img src="pictures/btn_support.jpg" alt="Support" title="Support" width="124" height="37" border="0" /></a><a href="<?php echo $GLOBALS["lang_dpg"]->str["lang_head_home_link"]; ?>" target="_blank"><img src="pictures/btn_home.jpg" alt="Home" title="Home" width="36" height="37" border="0" /></a>
                      </div>
                      <iframe frameborder="0" height="30" width="100%" id="news" name="news" scrolling="no" src="<?php echo $GLOBALS["lang_dpg"]->str["lang_head_newsticker_link"]; ?>" style="margin-top:33px;"></iframe>
                      <?php
                    }
                  ?>
                </td>
              </tr>
            </table>
				  </td>
				  <td valign="top" align="right" background="pictures/head-bg.jpg"><img src="pictures/head_right.jpg" alt="DynPG - Dynamic Pages"></td>
				 </tr>
				</table>
			</td>
		</tr>
		<tr>
			<td valign="top" align="left" width="100%" height="100%">
				<table border="0" Cellpadding="0" Cellspacing="0" width="100%" height="100%">
					<tr>

						<?php if ( VerifyAccess() ) { ?>

						<td width="150" valign="top">
							<table border="0" Cellpadding="0" Cellspacing="0" width="150">

								<?php require 'verticalmenu.php'; ?>

							</table>
						</td>

						<?php } ?>

						<td bgcolor="<?php echo C_WEBSITE_INNERBACKGROUND ?>" height="100%" valign="top" align="center">

						<!-- Begin individual context here -->
